-------------------------------------------------------------- 
--  Subject : OLE Automation 
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

  function CoInitialize() external
  function CoUninitialize() external

  constant
    DISPATCH_METHOD      = 1
    DISPATCH_PROPERTYGET = 2
    DISPATCH_PROPERTYPUT = 4
  end

  class Dispatch
    function Init( ServerName ) constructor
    function "[]"( N )
    function "/"( X, Y )
  end

  implementation Dispatch

    local V, shared ParamCount, shared ParamList, shared Assoc

    function CreateOleObject( var D, ServerName ) external
    function GetActiveOleObject( var D, ServerName ) external

    function Init( ServerName )
      S == Self()
      P == Assoc
      while not Null( P ) do
        if P[ 1 ][ 1 ] = ServerName then
          S := P[ 1 ][ 2 ]
        end
        P == P[ 2 ]
      end

      if Null( V ) then
        CreateOleObject( V, ServerName )
        Assoc := [ [ ServerName, Self() ], << Assoc ]
      end

      writeln( ServerName + ' is opened' )

    return 0

    function Call( ModeCall, Name, Params ) external

    function "/"( X, Y )

      P == Self()

      if not Null( ParamCount ) then

        Params := array( ParamCount )

        Q == ParamList
        while not Null( Q ) do
          Params[ ParamCount ] := Q[ 1 ]
          Dec( ParamCount )

          Q == Q[ 2 ]
        end
      else
        Params := []
      end

//      writeln( Params )
//      writeln( NameOf( Y ) )

      P := X.Call( DISPATCH_METHOD + DISPATCH_PROPERTYGET, NameOf( Y ), Params )

      Destroy( ParamCount )
      Destroy( ParamList  )
    return 0

    function "[]"( N )
      if Null( ParamCount ) then
        ParamCount := 0
      end
      Inc( ParamCount )
      ParamList := [ N, << ParamList ]
    return Self()

    function GetServersList()
    return AliasOf( AssocList )

  end

  function GetProperty( Disp, PropertyName, Params )
    object D : Dispatch
    D := Disp
    if ClassOf( Params ) = ClassArray then
      P := Params
    else
      P := [ Params ]
    end
  return D.Call( DISPATCH_PROPERTYGET, PropertyName, P )

  function PutProperty( Disp, PropertyName, Params )
    object D : Dispatch
    D := Disp
    if ClassOf( Params ) = ClassArray then
      P := Params
    else
      P := [ Params ]
    end
  return D.Call( DISPATCH_PROPERTYPUT, PropertyName, P )

  function MethodCall( Disp, MethodName, Params )
    object D : Dispatch
    D := Disp
    if ClassOf( Params ) = ClassArray then
      P := Params
    else
      P := [ Params ]
    end
  return D.Call( DISPATCH_METHOD, MethodName, P )

return
