-------------------------------------------------------------- 
--  Subject : DAO
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses com

constant
// RecordsetTypeEnum constants

  dbOpenTable = $00000001
  dbOpenDynaset = $00000002
  dbOpenSnapshot = $00000004
  dbOpenForwardOnly = $00000008
  dbOpenDynamic = $00000010

// EditModeEnum constants

  dbEditNone = $00000000
  dbEditInProgress = $00000001
  dbEditAdd = $00000002
  dbEditChanged = $00000004
  dbEditDeleted = $00000008
  dbEditNew = $00000010

// RecordsetOptionEnum constants

  dbDenyWrite = $00000001
  dbDenyRead = $00000002
  dbReadOnly = $00000004
  dbAppendOnly = $00000008
  dbInconsistent = $00000010
  dbConsistent = $00000020
  dbSQLPassThrough = $00000040
  dbFailOnError = $00000080
  dbForwardOnly = $00000100
  dbSeeChanges = $00000200
  dbRunAsync = $00000400
  dbExecDirect = $00000800

// LockTypeEnum constants

  dbPessimistic = $00000002
  dbOptimistic = $00000003
  dbOptimisticValue = $00000001
  dbOptimisticBatch = $00000005

// UpdateCriteriaEnum constants

  dbCriteriaKey = $00000001
  dbCriteriaModValues = $00000002
  dbCriteriaAllCols = $00000004
  dbCriteriaTimestamp = $00000008
  dbCriteriaDeleteInsert = $00000010
  dbCriteriaUpdate = $00000020

// FieldAttributeEnum constants

  dbFixedField = $00000001
  dbVariableField = $00000002
  dbAutoIncrField = $00000010
  dbUpdatableField = $00000020
  dbSystemField = $00002000
  dbHyperlinkField = $00008000
  dbDescending = $00000001

// DataTypeEnum constants

  dbBoolean = $00000001
  dbByte = $00000002
  dbInteger = $00000003
  dbLong = $00000004
  dbCurrency = $00000005
  dbSingle = $00000006
  dbDouble = $00000007
  dbDate = $00000008
  dbBinary = $00000009
  dbText = $0000000A
  dbLongBinary = $0000000B
  dbMemo = $0000000C
  dbGUID = $0000000F
  dbBigInt = $00000010
  dbVarBinary = $00000011
  dbChar = $00000012
  dbNumeric = $00000013
  dbDecimal = $00000014
  dbFloat = $00000015
  dbTime = $00000016
  dbTimeStamp = $00000017

  DataTypeEnum = ['Boolean',
                  'Byte',
                  'Integer',
                  'Long',
                  'Currency',
                  'Single',
                  'Double',
                  'Date',
                  'Binary',
                  'Text',
                  'LongBinary',
                  'Memo',
                  'GUID',
                  'BigInt',
                  'VarBinary',
                  'Char',
                  'Numeric',
                  'Decimal',
                  'Float',
                  'Time',
                  'TimeStamp']

// RelationAttributeEnum constants

  dbRelationUnique = $00000001
  dbRelationDontEnforce = $00000002
  dbRelationInherited = $00000004
  dbRelationUpdateCascade = $00000100
  dbRelationDeleteCascade = $00001000
  dbRelationLeft = $01000000
  dbRelationRight = $02000000

// TableDefAttributeEnum constants

  dbAttachExclusive = $00010000
  dbAttachSavePWD = $00020000
  dbSystemObject = $80000002
  dbAttachedTable = $40000000
  dbAttachedODBC = $20000000
  dbHiddenObject = $00000001

// QueryDefTypeEnum constants

  dbQSelect = $00000000
  dbQProcedure = $000000E0
  dbQAction = $000000F0
  dbQCrosstab = $00000010
  dbQDelete = $00000020
  dbQUpdate = $00000030
  dbQAppend = $00000040
  dbQMakeTable = $00000050
  dbQDDL = $00000060
  dbQSQLPassThrough = $00000070
  dbQSetOperation = $00000080
  dbQSPTBulk = $00000090
  dbQCompound = $000000A0

// QueryDefStateEnum constants

  dbQPrepare = $00000001
  dbQUnprepare = $00000002

// DatabaseTypeEnum constants

  dbVersion10 = $00000001
  dbEncrypt = $00000002
  dbDecrypt = $00000004
  dbVersion11 = $00000008
  dbVersion20 = $00000010
  dbVersion30 = $00000020

// CollatingOrderEnum constants

  dbSortNeutral = $00000400
  dbSortArabic = $00000401
  dbSortCyrillic = $00000419
  dbSortCzech = $00000405
  dbSortDutch = $00000413
  dbSortGeneral = $00000409
  dbSortGreek = $00000408
  dbSortHebrew = $0000040D
  dbSortHungarian = $0000040E
  dbSortIcelandic = $0000040F
  dbSortNorwdan = $00000406
  dbSortPDXIntl = $00000409
  dbSortPDXNor = $00000406
  dbSortPDXSwe = $0000041D
  dbSortPolish = $00000415
  dbSortSpanish = $0000040A
  dbSortSwedFin = $0000041D
  dbSortTurkish = $0000041F
  dbSortJapanese = $00000411
  dbSortChineseSimplified = $00000804
  dbSortChineseTraditional = $00000404
  dbSortKorean = $00000412
  dbSortThai = $0000041E
  dbSortSlovenian = $00000424
  dbSortUndefined = $FFFFFFFF

// IdleEnum constants

  dbFreeLocks = $00000001
  dbRefreshCache = $00000008

// PermissionEnum constants

  dbSecNoAccess = $00000000
  dbSecFullAccess = $000FFFFF
  dbSecDelete = $00010000
  dbSecReadSec = $00020000
  dbSecWriteSec = $00040000
  dbSecWriteOwner = $00080000
  dbSecDBCreate = $00000001
  dbSecDBOpen = $00000002
  dbSecDBExclusive = $00000004
  dbSecDBAdmin = $00000008
  dbSecCreate = $00000001
  dbSecReadDef = $00000004
  dbSecWriteDef = $0001000C
  dbSecRetrieveData = $00000014
  dbSecInsertData = $00000020
  dbSecReplaceData = $00000040
  dbSecDeleteData = $00000080

// SynchronizeTypeEnum constants

  dbRepExportChanges = $00000001
  dbRepImportChanges = $00000002
  dbRepImpExpChanges = $00000004
  dbRepSyncInternet = $00000010

// ReplicaTypeEnum constants

  dbRepMakeReadOnly = $00000002
  dbRepMakePartial = $00000001

// WorkspaceTypeEnum constants

  dbUseODBC = $00000001
  dbUseJet = $00000002

// CursorDriverEnum constants

  dbUseDefaultCursor = $FFFFFFFF
  dbUseODBCCursor = $00000001
  dbUseServerCursor = $00000002
  dbUseClientBatchCursor = $00000003
  dbUseNoCursor = $00000004

// DriverPromptEnum constants

  dbDriverPrompt = $00000002
  dbDriverNoPrompt = $00000001
  dbDriverComplete = $00000000
  dbDriverCompleteRequired = $00000003

// SetOptionEnum constants

  dbPageTimeout = $00000006
  dbLockRetry = $00000039
  dbMaxBufferSize = $00000008
  dbUserCommitSync = $0000003A
  dbImplicitCommitSync = $0000003B
  dbExclusiveAsyncDelay = $0000003C
  dbSharedAsyncDelay = $0000003D
  dbMaxLocksPerFile = $0000003E
  dbLockDelay = $0000003F
  dbRecycleLVs = $00000041
  dbFlushTransactionTimeout = $00000042

// ParameterDirectionEnum constants

  dbParamInput = $00000001
  dbParamOutput = $00000002
  dbParamInputOutput = $00000003
  dbParamReturnValue = $00000004

// UpdateTypeEnum constants

  dbUpdateBatch = $00000004
  dbUpdateRegular = $00000001
  dbUpdateCurrentRecord = $00000002

// RecordStatusEnum constants

  dbRecordUnmodified = $00000000
  dbRecordModified = $00000001
  dbRecordNew = $00000002
  dbRecordDeleted = $00000003
  dbRecordDBDeleted = $00000004

// CommitTransOptionsEnum constants
  dbForceOSFlush = $00000001

// _DAOSuppHelp constants
  LogMessages = $00000000
  KeepLocal = $00000000
  Replicable = $00000000
  ReplicableBool = $00000000
  V1xNullBehavior = $00000000
end

class DAOObject
  function GetRef()
  function SetRef( InitRef )
  function GetCollection( AName )
  function GetName()
  function PutName( AName )
  function GetType()
  function GetStrType()
  function PutType( AType )
  function GetValue()
  function PutValue( AValue )
  function "[]"( Name )
  function GetProp( Name )
  function PutProp( Name, AValue )
  function Call( MethodName, ParameterList )
end

class Collection : DAOObject
  function Append( AnObject )
  function Delete( ObjectName )
  function Refresh()
  function Count()
  function "[]"( N )
  function SetLocals( InitOwner, InitName )
end

class Property : DAOObject
  function "DAOObject"( N )
  function Inherited()
end

implementation DAOObject
  local Ref

  function "[]"( Name )
  return GetCollection( Name )

  function GetRef()
  return Ref

  function SetRef( InitRef )
    Ref := InitRef
  return Ref

  function GetCollection( Name )
    object C : Collection
    C.SetRef( GetProperty( GetRef(), Name, [] ) )
    C.SetLocals( Self(), Name )
  return C

  function GetName()
  return GetProperty( Ref, 'Name', [] )

  function PutName( AName )
  return PutProperty( Ref, 'Name', [ AName ] )

  function GetType()
  return GetProperty( Ref, 'Type', [] )

  function GetStrType()
    TypeID := GetType() 
    if ( TypeID >= 1 ) and ( TypeID <= Card( DataTypeEnum ) ) then
      R := DataTypeEnum[ TypeID ]
    else
      R := 'Unknown'
    end
  return R

  function PutType( AType )
  return PutProperty( Ref, 'Type', [ AType ] )

  function GetValue()
  return GetProperty( Ref, 'Value', [] )

  function PutValue( AValue )
  return PutProperty( Ref, 'Value', [ AValue ] )

  function GetProp( Name )
  return GetProperty( Ref, Name, [] )

  function PutProp( Name, AValue )
  return PutProperty( Ref, Name, [ AValue ] )

  function Call( MethodName, ParameterList )
  return MethodCall( Ref, MethodName, ParameterList )
end

implementation Collection

  local Owner, Name

  function Append( AnObject )
    object &P : DAOObject
    P == AnObject
  return MethodCall( GetRef(), 'Append', P.GetRef() )

  function Delete( ObjectName )
  return MethodCall( GetRef(), 'Delete', ObjectName )

  function Refresh()
  return MethodCall( GetRef(), 'Refresh', [] )

  function Count()
  return GetProperty( GetRef(), 'Count', [] )

  function "[]"( N )
    object &A, R : DAOObject
    A == Owner
    R.SetRef( GetProperty( A.GetRef(), Name, [ N ] ) )
  return R

  function SetLocals( InitOwner, InitName )
    Owner := InitOwner
    Name  := InitName
  return 0
end

implementation Property

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function Inherited()
  return GetProperty( GetRef(), 'Inherited', [] )
end

function DAO_OpenDatabase( DatabaseName )
   object DBEngine, Workspaces, OpenDatabase : Dispatch
   DBEngine.Init( 'DAO.DBEngine.36' )
return DBEngine/Workspaces[0]/OpenDatabase[ DatabaseName ]

return