-------------------------------------------------------------- 
--  Subject : DAO. Connection object
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses dao, daoqdef, daorec, daodb

class Connection : DAOObject
  function "DAOObject"( X )
  function Cancel()
  function Close()
  function CreateQueryDef( Name, SQLText )
  function Execute( Source, Options )
  function OpenRecordset( RecordsetName, OpenMode )
//Properties:
  function Database()
// Use GetProp and SetProp methods of DAOObject class to read/write 
// another properties of a Connection object
end

implementation Connection

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function Cancel()
  return Call( 'Cancel', [] )

  function Close()
  return Call( 'Close', [] )

  function CreateQueryDef( Name, SQLText )
    object QD : QueryDef
    QD.SetRef( Call( 'CreateQueryDef', [ Name, SQLText ] ) )
  return QD

  function OpenRecordset( RecordsetName, OpenMode )
    object RS : Recordset
    RS.SetRef( Call( 'OpenRecordset', [ RecordsetName, OpenMode ] ) )
  return RS

  function Execute( Source, Options )
  return Call( 'Execute', [ Source, Options ] )

  function Database()
    object DB : Database
    DB.SetRef( GetProp( 'Database' ) )
  return DB
end

return