-------------------------------------------------------------- 
--  Subject : DAO. Demo program
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

/*CreateTableDef Method Example

This example creates a new TableDef object in a database. */

uses com, dao, daodb, daotdef, daoengin

CoInitialize()

object DE : DBEngine
object DB : Database
object TD : TableDef
object P : Property
object Properties, Fields, TableDefs, Errors : Collection

try
  DE.Init( 'DAO.DBEngine.36' )

  DB := DE.OpenDatabase( 'Northwind.mdb', dummy, dummy, dummy )

// Create a new TableDef object.

  TD := DB.CreateTableDef( 'NewTable', dummy, dummy, dummy )

  Fields := TD[ 'Fields' ]

/* Create fields and append them to the new TableDef 
   object. This must be done before appending the 
   TableDef object to the TableDefs collection of the 
   Northwind database. */
  
  Fields.Append( TD.CreateField( 'Field1', dbInteger, 0 ) )
  Fields.Append( TD.CreateField( 'Field2', dbText, 50 ) )
  Fields.Append( TD.CreateField( 'Field3', dbMemo, 100 ) )

  Properties := TD[ 'Properties' ]

  writeln( 'Before appending to collection' )

// Enumerate Properties collection of new TableDef object.

  for I:=0 to Properties.Count() - 1 do
    P := Properties[I]
    try
      writeln('') 
      write( P.GetName() + ' as ' + P.GetStrType() + '=' )
      write( P.GetValue() )
      if P.GetType() = dbDate then
        write( ' decode as ' + DateToStr( P.GetValue() ) )
      end

    except
    end
  end

// Append the new TableDef object to the database.

  writeln('')
  writeln( 'Press Enter key' )
  Readln()

  TableDefs := DB[ 'TableDefs' ]

  TableDefs.Append( TD )

  writeln( 'After appending to collection' )

// Enumerate Properties collection of new TableDef object.

  for I:=0 to Properties.Count() - 1 do
    P := Properties[I]
    try
      writeln('') 
      write( P.GetName() + ' as ' + P.GetStrType() + '=' )
      write( P.GetValue() )
      if P.GetType() = dbDate then
        write( ' decode as ' + DateToStr( P.GetValue() ) )
      end

    except
    end
  end

// Delete new TableDef object since this is a demonstration.

  TableDefs.Delete( 'NewTable' )

  DB.Close()
  
finally
  CoUninitialize()
  writeln('')
  writeln( 'COM have closed' )
end

return
