-------------------------------------------------------------- 
--  Subject : DAO. DBEngine object
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses com, dao, daoworks, daodb, daoconn

class DBEngine : DAOObject
  function BeginTrans()
  function CommitTrans()
  function CompactDatabase( OldDB, NewDB, Locale, Options, Password )
  function CreateDatabase( Name, Locale, Options )
  function CreateWorkspace( Name, User, Password, Type )
  function Idle( X )
  function OpenConnection( Name, Options, ReadOnly, Connect )
  function OpenDatabase( Name, Options, ReadOnly, Connect )
  function RegisterDatabase( Name, Driver, Silent, Attributes )
  function RepairDatabase( Name )
  function RollBack()
  function SetOption( Parameter, NewValue )
//Properties:
  function GetSystemDB()
  function PutSystemDB( Name )
// Use GetProp and SetProp methods of DAOObject class to read/write 
// another properties of a DBEngine object
end

implementation DBEngine

   function Init( ServerName )
     object Engine : Dispatch
     Engine.Init( ServerName )
     SetRef( Engine )
   return 0

  function CreateWorkspace( Name, User, Password, Type )
    object WS : Workspace
    WS.SetRef( Call( 'CreateWorkspace', [ Name, User, Password, Type ] ) )
  return WS

  function OpenDatabase( Name, Options, ReadOnly, Connect )
    object DB : Database
    DB.SetRef( Call( 'OpenDatabase', [ Name, Options, ReadOnly, Connect ] ) )
  return DB

  function OpenConnection( Name, Options, ReadOnly, Connect )
    object C : Connection
    C.SetRef( Call( 'OpenConnection', [ Name, Options, ReadOnly, Connect ] ) )
  return C

  function RegisterDatabase( Name, Driver, Silent, Attributes )
  return Call( 'RegisterDatabase', [ Name, Driver, Silent, Attributes ] )

  function BeginTrans()
  return Call( 'BeginTrans', [] )

  function CommitTrans()
  return Call( 'CommitTrans', [] )

  function RollBack()
  return Call( 'RollBack', [] )

  function Idle( X )
  return Call( 'Idle', [ X ] )

  function CreateDatabase( Name, Locale, Options )
    object DB : Database
    DB.SetRef( Call( 'CreateDatabase', [ Name, Locale, Options ] ) )
  return DB

  function CompactDatabase( OldDB, NewDB, Locale, Options, Password )
  return Call( 'CompactDatabase', [ OldDB, NewDB, Locale, Options, Password ] )

  function RepairDatabase( Name )
  return Call( 'RepairDatabase', [ Name ] )

  function SetOption( Parameter, NewValue )
  return Call( 'SetOption', [ Parameter, NewValue ] )

  function GetSystemDB()
  return GetProp( 'SystemDB' )

  function PutSystemDB( Name )
  return PutProp( 'SystemDB', Name )
end

return