-------------------------------------------------------------- 
--  Subject : DAO. QueryDef object
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses dao, daorec

class QueryDef : DAOObject
  function "DAOObject"( X )
  function Cancel()
  function Close()
  function CreateProperty()
  function OpenRecordset( OpenMode, Options, Lockedits )
  function Execute( Source, Options )
//Properties:
  function GetSQL()
  function SetSQL( SQLText )
// Use GetProp and SetProp methods of DAOObject class to read/write 
// another properties of a QueryDef object
end

implementation QueryDef

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function CreateProperty()
    object P : Property
    P.SetRef( Call( 'CreateProperty', [] ) )
  return P

  function Close()
  return Call( 'Close', [] )

  function Cancel()
  return Call( 'Cancel', [] )

  function OpenRecordset( OpenMode, Options, Lockedits )
    object RS : Recordset
    RS.SetRef( Call( 'OpenRecordset', [ OpenMode, Options, Lockedits ] ) )
  return RS

  function Execute( Source, Options )
  return Call( 'Execute', [ Source, Options ] )

  function GetSQL()
  return GetProp( 'SQL' )

  function SetSQL( SQLText )
  return PutProp( 'SQL', SQLText )
end

return