-------------------------------------------------------------- 
--  Subject : DAO. Workspace object
--  Copyright (c) 2000 by A.Baranovsky
--------------------------------------------------------------

uses dao, daouser, daodb, daoconn

class Workspace : DAOObject
  function "DAOObject"( X )
  function BeginTrans()
  function Close()
  function CommitTrans()
  function CreateDatabase( Name, Locale, Options )
  function CreateGroup( Name )
  function CreateUser( Name )
  function OpenConnection( Name, Options, ReadOnly, Connect )
  function OpenDatabase( Name, Options, ReadOnly, Connect )
  function RollBack()
// Use GetProp and SetProp methods of DAOObject class to read/write 
// properties of a Workspace object
end

implementation Workspace

  function "DAOObject"( X )
    SetRef( X.GetRef() )
  return Self()

  function CreateUser( Name )
    object U : User
    U.SetRef( Call( 'CreateUser', [ Name ] ) )
  return U

  function CreateGroup( Name )
    object G : Group
    G.SetRef( Call( 'CreateGroup', [ Name ] ) )
  return G

  function BeginTrans()
  return Call( 'BeginTrans', [] )

  function CommitTrans()
  return Call( 'CommitTrans', [] )

  function RollBack()
  return Call( 'RollBack', [] )

  function Close()
  return Call( 'Close', [] )

  function CreateDatabase( Name, Locale, Options )
    object DB : Database
    DB.SetRef( Call( 'CreateDatabase', [ Name, Locale, Options ] ) )
  return DB

  function OpenDatabase( Name, Options, ReadOnly, Connect )
    object DB : Database
    DB.SetRef( Call( 'OpenDatabase', [ Name, Options, ReadOnly, Connect ] ) )
  return DB

  function OpenConnection( Name, Options, ReadOnly, Connect )
    object C : Connection
    C.SetRef( Call( 'OpenConnection', [ Name, Options, ReadOnly, Connect ] ) )
  return C
end

return