--------------------------------------------------------------  
--  Subject : Linear algebra, Determinant
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

function Determinant( A, N )
  D := 1.0
  for K := 1 to N do
    Max := 0.0 
    for I := K to N do
      T := A[ I, K ]
      if Abs( T ) > Abs( Max ) then
        Max := T
        J := I
      end
    end
    if Max = 0.0 then
      D := 0.0
      goto Fin
    end
    if J <> K then
      D := - D
      for I:=K to N do
        Swap( A[ I, J ], A[ K, I ] )
      end
    end
    for I:= K + 1 to N do
      T := A[ I, K ] / Max
      for J:= K + 1 to N do
        A[ I, J ] := A[ I, J ] - T * A[ K, J ]
      end
    end
    D := D * A[ K, K ]
  end
  label Fin
return D

-------- Main program -----------

A := array( 3 )

A[1] := [ 10.96597, 35.10765, 96.72356 ]
A[2] := [  2.35765,-84.11256,  0.87932 ]
A[3] := [ 18.24689, 22.13579,  1.11123 ] 

D := Determinant( A, 3 )

writeln( D )

return 