-------------------------------------------------------------- 
--  Subject : Sorting
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

function QuickSort( var A, L, H )
  I := L
  J := H
  X := A[ ( I + J ) / 2 ]
  repeat
    while A[ I ] < X do
      I := I + 1
    end
    while X < A[ J ] do
      J := J - 1
    end
    if I <= J then
      Swap( A[ I ], A[ J ] )
      I := I + 1
      J := J - 1
    end
  until I > J
  if L < J then
    QuickSort( A, L, J )
  end
  if I < H then
    QuickSort( A, I, H )
  end
return 0

function BubbleSort( var A )
  N := Card( A )
  for I:=2 to N do
    J := N
    while J >= I do
      if A[ J - 1 ] > A[ J ] then
        Swap( A[ J - 1 ], A[ J ] ) 
      end
      Dec( J )
    end
  end
return 0

function StraightSelection( var A )
  N := Card( A )
  for I:=1 to N - 1 do
    K := I
    X := A[ I ]
    for J:=I+1 to N do
      if A[ J ] < X then
        K := J 
        X := A[ K ]
      end
    end
    A[ K ] := A[ I ]
    A[ I ] := X
  end 
return 0

function TestArray( N )
  A := array( N )
  for I:=1 to N do
    A[I] := Random(100)
  end
return A

A := TestArray(20)
QuickSort( A, 1, Card(A) )
writeln( A )

A := TestArray(20)
BubbleSort( A )
writeln( A )

A := TestArray(20)
StraightSelection( A )
writeln(A)

return
